/// <reference path="../Language.d.ts" />
/// <reference path="../Builtins.d.ts" />
import { deepMerge } from '../utils';
import { IR, verb, not, at, RenderingOptions } from '../DefaultIR';
export declare type German = {
    k: 'noun_';
    article_: '' | 'ein' | 'eine';
    noun_: string;
    name_: string;
};
declare function haben(name: string): (ir: IR<German>) => IR<German>;
export declare const deDEOptions: RenderingOptions<German, string>;
export declare const deDE: {
    renderer: import("bueno/locale").MessageRenderer<IR<{
        k: "noun_";
        article_: "" | "ein" | "eine";
        noun_: string;
        name_: string;
    }>, string>;
    builder: {
        mustBe: (msgs: string | import("../DefaultIR").Message<any> | {
            k: "when";
            cond: IR<any>[];
            conseq: IR<any>;
        }, name?: string | undefined) => IR<any>;
        mustHave: (ir: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>) => IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        has: typeof haben;
        length: (ir: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>) => IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        sum: (ir: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>) => IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        atEvery(ir: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>): IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        more<A>(n: A): IR<any>;
        less<A_1>(n: A_1): IR<any>;
        atLeast<A_2>(lb: A_2): IR<any>;
        between<A_3>(lb: A_3, ub: A_3): IR<any>;
        atMost<A_4>(ub: A_4): IR<any>;
        oneOf<A_5>(choices: A_5[]): IR<any>;
        exactly<A_6>(target: A_6): IR<any>;
        keys(keys: string[]): IR<unknown>;
        email: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        alphanum: IR<any>;
        uuid: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        url: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        even: IR<any>;
        odd: IR<any>;
        empty: IR<any>;
        date: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        iterable: IR<any>;
        array: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        string: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        set: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        map: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        bool: import("../DefaultIR").Message<any> & {
            k: "when";
            cond: IR<any>[];
            conseq: IR<any>;
        };
        number: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        integer: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        object: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        leftOut: IR<any>;
        json: IR<{
            k: "noun_";
            article_: "" | "ein" | "eine";
            noun_: string;
            name_: string;
        }>;
        not: typeof not;
        either: typeof deepMerge;
        when: <A_7>(conseq: IR<A_7>, cond: IR<A_7>[]) => IR<A_7>;
        at: typeof at;
        fromString: (noun_: string, name_?: string) => IR<any>;
        verb: typeof verb;
    };
};
export {};
