/// <reference path="../Language.d.ts" />
/// <reference path="../Builtins.d.ts" />
import { IR, RenderingOptions } from '../DefaultIR';
import '../Builtins';
import { MessageBuilder } from 'bueno/locale';
export declare type English = {
    k: 'noun_';
    article_: '' | 'a' | 'an';
    noun_: string;
    name_: string;
};
export declare function groupByArticle(words: English[]): {
    [key in English['article_']]?: English[];
};
export declare function renderEnglishAtom<O>(nouns: English[], props: RenderingOptions<English, O>): O;
export declare const enUSOptions: RenderingOptions<English, string>;
export declare const enUS: {
    renderer: import("bueno/locale").MessageRenderer<IR<{
        k: "noun_";
        article_: "" | "a" | "an";
        noun_: string;
        name_: string;
    }>, string>;
    builder: MessageBuilder<IR<{
        k: "noun_";
        article_: "" | "a" | "an";
        noun_: string;
        name_: string;
    }>>;
};
