/// <reference path="../Language.d.ts" />
/// <reference path="../Builtins.d.ts" />
import { deepMerge } from '../utils';
import { IR, verb, not, at, RenderingOptions } from '../DefaultIR';
export declare type Swedish = {
    k: 'noun_';
    article_: '' | 'en' | 'ett';
    noun_: string;
    name_: string;
};
declare function has(name: string): (ir: IR<Swedish>) => IR<Swedish>;
export declare const svSEOptions: RenderingOptions<Swedish, string>;
export declare const svSE: {
    renderer: import("bueno/locale").MessageRenderer<IR<{
        k: "noun_";
        article_: "" | "en" | "ett";
        noun_: string;
        name_: string;
    }>, string>;
    builder: {
        mustBe: (msgs: string | import("../DefaultIR").Message<any> | {
            k: "when";
            cond: IR<any>[];
            conseq: IR<any>;
        }, name?: string | undefined) => IR<any>;
        mustHave: (msgs: string | import("../DefaultIR").Message<any> | {
            k: "when";
            cond: IR<any>[];
            conseq: IR<any>;
        }, name?: string | undefined) => IR<any>;
        has: typeof has;
        length: (ir: IR<{
            k: "noun_";
            article_: "" | "en" | "ett";
            noun_: string;
            name_: string;
        }>) => IR<{
            k: "noun_";
            article_: "" | "en" | "ett";
            noun_: string;
            name_: string;
        }>;
        sum: (ir: IR<{
            k: "noun_";
            article_: "" | "en" | "ett";
            noun_: string;
            name_: string;
        }>) => IR<{
            k: "noun_";
            article_: "" | "en" | "ett";
            noun_: string;
            name_: string;
        }>;
        atEvery(ir: IR<{
            k: "noun_";
            article_: "" | "en" | "ett";
            noun_: string;
            name_: string;
        }>): IR<{
            k: "noun_";
            article_: "" | "en" | "ett";
            noun_: string;
            name_: string;
        }>;
        more<A>(n: A): IR<any>;
        less<A_1>(n: A_1): IR<any>;
        atLeast<A_2>(lb: A_2): IR<any>;
        between<A_3>(lb: A_3, ub: A_3): IR<any>;
        atMost<A_4>(ub: A_4): IR<any>;
        oneOf<A_5>(choices: A_5[]): IR<any>;
        exactly<A_6>(target: A_6): IR<any>;
        keys(keys: string[]): IR<any>;
        email: IR<any>;
        alphanum: IR<any>;
        uuid: IR<any>;
        url: IR<any>;
        even: IR<any>;
        odd: IR<any>;
        empty: IR<any>;
        date: IR<any>;
        iterable: IR<any>;
        array: IR<any>;
        string: IR<any>;
        set: IR<any>;
        map: IR<any>;
        bool: import("../DefaultIR").Message<any> & {
            k: "when";
            cond: IR<any>[];
            conseq: IR<any>;
        };
        number: IR<any>;
        integer: IR<any>;
        object: IR<any>;
        leftOut: IR<any>;
        json: IR<any>;
        not: typeof not;
        either: typeof deepMerge;
        when: <A_7>(conseq: IR<A_7>, cond: IR<A_7>[]) => IR<A_7>;
        at: typeof at;
        fromString: (noun_: string, name_?: string) => IR<any>;
        verb: typeof verb;
    };
};
export {};
