import { ParseResult, Parser_, Schema_, Schema, Parser, SchemaFactory } from '../../types';
import { Action } from '../../action';
import { Message } from 'bueno/locale';
export declare function notP<A, B>(v: Parser<A, B>): Parser_<A, B>;
export declare function eitherP<A, B, C, D>(v: Parser<A, C>, w: Parser<B, D>): Parser_<A | B, C | D>;
export declare function either<A, B, C, D>(v: Schema<A, C>, w: Schema<B, D>): Schema_<A | B, C | D>;
export declare function merge<A, B>(a: A, b: B): A & B;
export declare function bothP<A, B, C, D>(v: Parser<A, C>, w: Parser<B, D>): Parser_<A & B, C & D>;
export declare function both<A, B, C, D>(v: Schema<A, C>, w: Schema<B, D>): Schema_<A & B, C & D>;
export declare function pipeP<A, B, C>(v: Parser<A, B>, w: Parser<B, C>): Parser_<A, C>;
export declare function pipe<A, B, C>(s: Schema<A, B>, t: Schema<B, C>): Schema_<A, C>;
export declare const anyP: Parser_<any, any>;
export declare const any: Schema_<any, any>;
export declare const id: <A = any>() => Schema_<A, A>;
export declare function everyP<A, B>(vs: Parser<A, B>[]): Parser_<A, B>;
export declare function every<A, B>(...vs: Schema<A, B>[]): Schema_<A, B>;
export declare function forgetP<A, B>(v: Parser<A, B>): Parser_<A, A>;
export declare function forget<A, B>(schema: Schema_<A, B>): Schema_<A, A>;
export declare function mkSchema<A, B>(parse: Parser_<A, B>, unparse?: Parser_<B, A>): Schema_<A, B>;
export declare function mkParserCallable<A, B>(fn: (a: A, inverted: boolean) => Action<ParseResult<B>>): Parser_<A, B>;
export declare function mkParser<A, B>(check: SchemaFactory<A, B>): Parser_<A, B>;
export declare type InternalParserFactory<A, B> = (a: A) => Action<{
    parse_?: {
        ok: boolean;
        msg: string | Message;
    };
    validate_?: {
        ok: boolean;
        msg: string | Message;
    };
    result_?: B;
    score_?: number;
}>;
export declare function mkParser_<A, B>(check: InternalParserFactory<A, B>): Parser_<A, B>;
