import { Action } from './action';
import { CNF } from './logic';
import { Err, Message } from 'bueno/locale';
export declare type ParseResult<B> = {
    cnf_: () => Action<CNF<Err>>;
    res_: () => Action<B>;
    score_: number;
};
export interface Parser<A, B> {
    run_: (a: A, inverted: boolean) => Action<ParseResult<B>>;
}
export interface Parser_<A, B> extends Parser<A, B> {
    (...vs: Parser_<B, B>[]): Parser_<A, B>;
}
export interface Schema<A, B = A> {
    parse_: Parser_<A, B>;
    unparse_: Parser_<B, A>;
}
export interface Schema_<A, B = A> extends Schema<A, B> {
    (...ss: Schema<B, B>[]): Schema_<A, B>;
}
export declare type SchemaFactory<A, B> = (a: A) => Action<{
    parse?: {
        ok: boolean;
        msg: Message;
    };
    validate?: {
        ok: boolean;
        msg: Message;
    };
    result?: B;
    score?: number;
}>;
export declare type UndefinedOptional<A> = {
    [P in keyof A]?: A[P];
} & {
    [L in {
        [K in keyof A]: undefined extends A[K] ? never : K;
    }[keyof A]]: A[L];
};
export declare type ForgetfulValidator<A, B> = <C extends A>(...vs: Parser_<B, B>[]) => Parser_<C, C>;
export declare type ForgetfulSchema<A, B> = (...vs: Schema<B, B>[]) => Schema_<A, A>;
export declare type Messages = string | {
    [k in string]: Messages;
};
export declare type Obj = Record<string, unknown>;
