declare module 'bueno/locale' {
    interface MessageBuilder<IR> extends MessageBuilderBase<IR> {
    }
    type VerbBuilder = (s: any) => any[];
    interface MessageBuilderBase<IR> {
        not(ir: IR): IR;
        either(disj: IR[]): IR;
        when(conseq: IR, cond: IR[]): IR;
        at<K extends string>(pfx: K, rs: IR): IR;
        atEvery(rs: IR): IR;
        fromString(s: string): IR;
        verb(is: VerbBuilder, not: VerbBuilder, when?: VerbBuilder, whenNot?: VerbBuilder, passive?: VerbBuilder, passiveNot?: VerbBuilder): (msgs: string | IR) => IR;
    }
    type GroupedByKey<Output> = {
        [key in string]: GroupedByKey<Output>;
    } | Output;
    type Paths<Out> = [string, Out][];
    type MessageRenderer<IR, Output = string> = MessageRendererBase<IR, Output>;
    interface MessageRendererBase<IR, Output = string> {
        render(ir: IR, paths: [string, Output][]): Output;
        byKey(ir: IR, paths: [string, Output][]): GroupedByKey<Output>;
    }
    interface Language<IR, Out = string> {
        renderer: MessageRenderer<IR, Out>;
        builder: MessageBuilder<IR>;
    }
    type Message = <IR>(l: MessageBuilder<IR>) => IR;
    type Err = {
        k: 'v' | 'p';
        m: Message;
        ok: boolean;
    };
}
