import { Parser, Schema } from '../types';
import { Errors } from '../schema/runners/checkByKey';
import { Action } from '../action';
import { Locale } from '../index';
export declare function run<A, B>(v: Parser<A, B>, a: unknown): Promise<[string[], B, number]>;
export declare function parseAsync<A, B>(value: A, schema: Schema<A, B>, language: Locale): Action<{
    result: B;
    error: string | null;
    errorsByKey: Errors<B>;
}>;
export declare const parse: <A, B>(value: A, schema: Schema<A, B>, language: Locale) => {
    result: B;
    error: string | null;
    errorsByKey: Errors<B>;
};
export declare const unparse: <A, B>(v: B, s: Schema<A, B>, l: Locale) => {
    result: A;
    error: string | null;
    errorsByKey: Errors<A>;
};
