import { Message } from "bueno/locale";
export declare const id: <A>(x: A) => A;
export declare const isDigits: (x: string) => boolean;
export declare function isEmpty<A>(a: A[]): boolean;
export declare function isString(a: any): boolean;
export declare function isNumber(a: any): boolean;
export declare function isPromise(a: any): boolean;
export declare function constant<A>(a: A): () => A;
export declare function push<A>(a: A, as: A[]): A[];
export declare function entries<A extends symbol | string | number, B>(obj: {
    [key in A]: B;
}): [A, B][];
export declare function fromEntries<A extends symbol | string | number, B>(entries: [A, B][]): {
    [key in A]: B;
};
export declare function mapEntries<A, B, K extends string | number | symbol>(obj: {
    [key in K]: A;
}, f: (key: K, val: A) => [K, B]): {
    [key in K]: B;
};
export declare function isIterable(a: any): a is Iterable<any>;
export declare function average(scores: number[]): number;
export declare function mapValues<KS extends string, A, B>(x: {
    [key in KS]: A;
}, f: (a: A) => B): {
    [key in KS]: B;
};
export declare function assignPath<A>(obj: any, path: string[], val: A): any;
export declare function joinWithCommas(as: string[], separator: string): string;
export declare function capFirst(s: string): string;
export declare function isObject(obj: any): boolean;
export declare const isArray: (arg: any) => arg is any[];
export declare const keys: {
    (o: object): string[];
    (o: {}): string[];
};
declare type TUnionToIntersection<U> = (U extends any ? (k: U) => void : never) extends (k: infer I) => void ? I : never;
export declare function deepMerge<T extends {
    [key: string]: any;
}[]>(objects: T): TUnionToIntersection<T[number]>;
export declare function words(args: string[]): string;
export declare function byEmpty(x: string, y: string): number;
export declare function getParse(x: {
    parse_: any;
}): any;
export declare function getUnparse(x: {
    unparse_: any;
}): any;
export declare function toMessage(s: string | Message): Message;
export declare function compose<A, B, C>(f: (a: A) => B, g: (b: B) => C): (a: A) => C;
export {};
